import TimedAutomaton
import RegionAutomaton
import ZoneAutomaton
import RegionReach
import ZoneReach

-- Dummy automaton for tests

x = Clock "x"
y = Clock "y"

yEq1 = EqualTo (y,1)
xLo1 = LowerThan (x,1)
yLo1 = LowerThan (y,1)
xGr1 = GreaterThan (x,1)

s0 = Location "s0"
s1 = Location "s1"
s2 = Location "s2"
s3 = Location "s3"

la = Label "a"
lb = Label "b"
lc = Label "c"
ld = Label "d"

t0 = Transition { source=s0, guard=[], label=la, resets=[y], target=s1 }
t1 = Transition { source=s1, guard=[yEq1], label=lb, resets=[], target=s2 }
t2 = Transition { source=s1, guard=[xLo1], label=lc, resets=[], target=s3 }
t3 = Transition { source=s2, guard=[xLo1], label=lc, resets=[], target=s3 }
t4 = Transition { source=s3, guard=[xGr1], label=ld, resets=[], target=s3 }
t5 = Transition { source=s3, guard=[yLo1], label=la, resets=[y], target=s1 }

a = Automaton { initial=s0, goals=[], clocks=[x,y], transitions=[t0,t1,t2,t3,t4,t5] }

ra = regionAutomaton a
ra' = strictRegionAutomaton a
za = zoneAutomatonEquality a
za' = futurZoneAutomatonEquality a
za'' = zoneAutomatonInclusion a
za''' = futurZoneAutomatonInclusion a

-- Main

main = 
   do
      print a
      print ra
      print ra'
      print za
      print za'
      print za''
      print za'''